//+------------------------------------------------------------------+
//|                                      i_MTF_Alex_Activity_v02.mq4 |
//------------------------------------------------------------------
#property copyright "fion"
#property link      ""
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  LimeGreen
#property indicator_color4  PaleVioletRed
#property indicator_color5  LimeGreen
#property indicator_color6  PaleVioletRed
#property indicator_color7  LimeGreen
#property indicator_color8  PaleVioletRed
#property indicator_minimum 0
#property indicator_maximum 5

//
extern string TimeFrame1            = "Current time frame";
extern string TimeFrame2            = "next1";
extern string TimeFrame3            = "next2";
extern string TimeFrame4            = "next3";
extern int    BARS_Period           =  4;// 
extern string UniqueID              = "4 Time frames Activity";
extern int    LinesWidth            =  0;
extern color  LabelsColor           = DarkGray;
extern int    LabelsHorizontalShift = 5;
extern double LabelsVerticalShift   = 1.5;
extern int    CalculateBars         = 1000;
//

double sar1u[];
double sar1d[];
double sar2u[];
double sar2d[];
double sar3u[];
double sar3d[];
double sar4u[];
double sar4d[];

int    timeFrames[4],mp,prevtime;
bool   returnBars;
bool   calculateValue;
string indicatorFileName;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   SetIndexBuffer(0,sar1u);
   SetIndexBuffer(1,sar1d);
   SetIndexBuffer(2,sar2u);
   SetIndexBuffer(3,sar2d);
   SetIndexBuffer(4,sar3u);
   SetIndexBuffer(5,sar3d);
   SetIndexBuffer(6,sar4u);
   SetIndexBuffer(7,sar4d);
   indicatorFileName = WindowExpertName();
   //    
      for (int i=0; i<8; i++) 
      {
         SetIndexStyle(i,DRAW_ARROW,EMPTY,LinesWidth); SetIndexArrow(i,110); 
      }
      timeFrames[0] = stringToTimeFrame(TimeFrame1);
      timeFrames[1] = stringToTimeFrame(TimeFrame2);
      timeFrames[2] = stringToTimeFrame(TimeFrame3);
      timeFrames[3] = stringToTimeFrame(TimeFrame4);
      IndicatorShortName(UniqueID);
    mp=1; if(Digits==3 || Digits==5)mp=10;
   return(0);
}

int deinit()
{
   for (int t=0; t<4; t++) ObjectDelete(UniqueID+t);
   return(0); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
double trend[];

int start()
{
   int i,r,count,counted_bars=IndicatorCounted();
   if (ArraySize(trend)!=Bars) ArrayResize(trend,Bars);
         //
         bool initialized = false;
         if (!initialized)
         {
            initialized = true;
            int window = WindowFind(UniqueID);
            for (int t=0; t<4; t++)
            {
               string label = timeFrameToString(timeFrames[t]);
               ObjectCreate(UniqueID+t,OBJ_TEXT,window,0,0);
                  ObjectSet(UniqueID+t,OBJPROP_COLOR,LabelsColor);
                  ObjectSet(UniqueID+t,OBJPROP_PRICE1,t+LabelsVerticalShift);
                  ObjectSetText(UniqueID+t,label,8,"Arial");
            }               
         }
         for (t=0; t<4; t++) ObjectSet(UniqueID+t,OBJPROP_TIME1,Time[0]+Period()*LabelsHorizontalShift*60);

   //
   if(prevtime==Time[0])return(0); prevtime=Time[0];
   for(i = CalculateBars, r=CalculateBars-i-1; i >= 0; i--,r++)
   {
      trend[r] = 0;
      for (int k=0; k<4; k++)
      {
         int y = iBarShift(NULL,timeFrames[k],Time[i]);
            double sarc = Summa(timeFrames[k],y,BARS_Period);
            switch (k)
            {
               case 0 : sar1d[i] = EMPTY_VALUE; sar1u[i] = EMPTY_VALUE; if (sarc==0)break; if (sarc>=0) sar1u[i] = k+1; if (sarc<0) sar1d[i] = k+1; break;
               case 1 : sar2d[i] = EMPTY_VALUE; sar2u[i] = EMPTY_VALUE; if (sarc==0)break; if (sarc>=0) sar2u[i] = k+1; if (sarc<0) sar2d[i] = k+1; break;
               case 2 : sar3d[i] = EMPTY_VALUE; sar3u[i] = EMPTY_VALUE; if (sarc==0)break; if (sarc>=0) sar3u[i] = k+1; if (sarc<0) sar3d[i] = k+1; break;
               case 3 : sar4d[i] = EMPTY_VALUE; sar4u[i] = EMPTY_VALUE; if (sarc==0)break; if (sarc>=0) sar4u[i] = k+1; if (sarc<0) sar4d[i] = k+1; break;
            }
            trend[r] += sarc;
      }
   }
  
   return(0);
}



//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
int Summa(int tf, int shift,int bars){
int summa=0;
for(int i=shift; i<shift+bars; i++)
   {
    if(iClose(NULL,tf,i)-iOpen(NULL,tf,i)>=0)summa+=(iClose(NULL,tf,i)-iOpen(NULL,tf,i))/Point;
     else summa+=-(iOpen(NULL,tf,i)-iClose(NULL,tf,i))/Point;
   }
return (summa/mp);
}
//
//-------------------------------------------------------------------
string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
int toInt(double value) { return(value); }
int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   int max = ArraySize(iTfTable)-1, add=0;
   int nxt = (StringFind(tfs,"NEXT1")>-1); if (nxt>0) { tfs = ""+Period(); add=1; }
       nxt = (StringFind(tfs,"NEXT2")>-1); if (nxt>0) { tfs = ""+Period(); add=2; }
       nxt = (StringFind(tfs,"NEXT3")>-1); if (nxt>0) { tfs = ""+Period(); add=3; }
      //
         
      for (int i=max; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[toInt(MathMin(max,i+add))],Period()));
                                                      return(Period());
}

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}